Archived
2
0
This repository has been archived on 2024-06-24. You can view files and clone it, but cannot push or open issues or pull requests.
neko-custom/.docker/base/Dockerfile

139 lines
3.7 KiB
Docker
Raw Normal View History

2020-06-17 10:32:34 +12:00
#
# STAGE 1: SERVER
#
2023-02-24 06:23:34 +13:00
FROM golang:1.20-bullseye as server
2020-06-17 10:32:34 +12:00
WORKDIR /src
#
# install dependencies
RUN set -eux; apt-get update; \
apt-get install -y --no-install-recommends git cmake make libx11-dev libxrandr-dev libxtst-dev \
2020-09-24 18:09:02 +12:00
libgstreamer1.0-dev libgstreamer-plugins-base1.0-dev gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-plugins-ugly; \
2020-06-17 10:32:34 +12:00
#
# install libclipboard
set -eux; \
cd /tmp; \
git clone --depth=1 https://github.com/jtanx/libclipboard; \
2020-06-17 10:32:34 +12:00
cd libclipboard; \
cmake .; \
make -j4; \
make install; \
rm -rf /tmp/libclipboard; \
#
# clean up
apt-get clean -y; \
rm -rf /var/lib/apt/lists/* /var/cache/apt/*
#
# build server
COPY server/ .
2021-03-29 08:44:43 +13:00
RUN go get -v -t -d . && go build -o bin/neko cmd/neko/main.go
2020-06-17 10:32:34 +12:00
#
# STAGE 2: CLIENT
#
2023-01-22 11:43:04 +13:00
FROM node:18-bullseye-slim as client
2020-06-17 10:32:34 +12:00
WORKDIR /src
#
# install dependencies
COPY client/package*.json ./
RUN npm install
#
# build client
COPY client/ .
RUN npm run build
#
# STAGE 3: RUNTIME
#
2021-09-01 04:27:46 +12:00
FROM debian:bullseye-slim
2020-06-17 10:32:34 +12:00
#
# avoid warnings by switching to noninteractive
ENV DEBIAN_FRONTEND=noninteractive
#
# set custom user
ARG USERNAME=neko
ARG USER_UID=1000
ARG USER_GID=$USER_UID
RUN set -eux; \
apt-get update; \
#
# install dependencies
2020-06-17 10:32:34 +12:00
apt-get install -y --no-install-recommends wget ca-certificates supervisor; \
2021-09-01 04:45:25 +12:00
apt-get install -y --no-install-recommends pulseaudio dbus-x11 xserver-xorg-video-dummy; \
2021-09-01 04:27:46 +12:00
apt-get install -y --no-install-recommends libcairo2 libxcb1 libxrandr2 libxv1 libopus0 libvpx6; \
2020-06-17 10:32:34 +12:00
#
# gst
2020-06-17 10:32:34 +12:00
apt-get install -y --no-install-recommends libgstreamer1.0-dev libgstreamer-plugins-base1.0-dev \
gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-plugins-ugly gstreamer1.0-pulseaudio; \
2020-06-17 10:32:34 +12:00
#
2022-10-25 06:37:42 +13:00
# install fonts
apt-get install -y --no-install-recommends \
# Google emojis
fonts-noto-color-emoji \
# Japanese fonts
fonts-takao-mincho \
# Chinese fonts
fonts-wqy-zenhei xfonts-intl-chinese xfonts-wqy \
# Korean fonts
fonts-wqy-microhei; \
2021-11-05 08:12:14 +13:00
#
2020-06-17 10:32:34 +12:00
# create a non-root user
groupadd --gid $USER_GID $USERNAME; \
useradd --uid $USER_UID --gid $USERNAME --shell /bin/bash --create-home $USERNAME; \
adduser $USERNAME audio; \
adduser $USERNAME video; \
adduser $USERNAME pulse; \
#
# workaround for an X11 problem: http://blog.tigerteufel.de/?p=476
mkdir /tmp/.X11-unix; \
chmod 1777 /tmp/.X11-unix; \
chown $USERNAME /tmp/.X11-unix/; \
#
# make directories for neko
2023-04-10 01:42:33 +12:00
mkdir -p /etc/neko /var/www /var/log/neko \
/tmp/runtime-$USERNAME \
/home/$USERNAME/.config/pulse \
/home/$USERNAME/.local/share/xorg; \
2020-06-17 10:32:34 +12:00
chmod 1777 /var/log/neko; \
2023-04-10 01:42:33 +12:00
chown $USERNAME /var/log/neko/ /tmp/runtime-$USERNAME; \
2020-06-17 10:32:34 +12:00
chown -R $USERNAME:$USERNAME /home/$USERNAME; \
#
# clean up
apt-get clean -y; \
rm -rf /var/lib/apt/lists/* /var/cache/apt/*
#
# copy config files
2021-11-28 02:23:33 +13:00
COPY .docker/base/dbus /usr/bin/dbus
COPY .docker/base/default.pa /etc/pulse/default.pa
COPY .docker/base/supervisord.conf /etc/neko/supervisord.conf
COPY .docker/base/xorg.conf /etc/neko/xorg.conf
2020-06-17 10:32:34 +12:00
#
# set default envs
ENV USER=$USERNAME
ENV DISPLAY=:99.0
2023-03-27 07:13:35 +13:00
ENV PULSE_SERVER=unix:/tmp/pulseaudio.socket
2023-04-10 01:42:33 +12:00
ENV XDG_RUNTIME_DIR=/tmp/runtime-$USERNAME
2020-06-17 10:32:34 +12:00
ENV NEKO_PASSWORD=neko
ENV NEKO_PASSWORD_ADMIN=admin
ENV NEKO_BIND=:8080
#
# copy static files from previous stages
COPY --from=server /src/bin/neko /usr/bin/neko
COPY --from=client /src/dist/ /var/www
2021-03-20 02:42:54 +13:00
HEALTHCHECK --interval=10s --timeout=5s --retries=8 \
CMD wget -O - http://localhost:${NEKO_BIND#*:}/health || exit 1
2020-06-17 10:32:34 +12:00
#
# run neko
CMD ["/usr/bin/supervisord", "-c", "/etc/neko/supervisord.conf"]